//+------------------------------------------------------------------+
//| Doc Sequential histo.mq4                                         |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  4
#property indicator_color1   LimeGreen
#property indicator_color2   Orange
#property indicator_color3   Green
#property indicator_color4   Red
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property indicator_width4   2

//
//
//
//
//

extern int    TrendAlignIndicators        =    5;
extern int    TrendToolBars.Length        =    5;
extern int    PriceChannel.ChannelPeriod  =    5; //Price Channel Period
extern double PriceChannel.Risk           = 0.30; //channel narrowing factor (0...0,5)  
extern int    PriceChannel.Signal         =    1; //Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
extern int    PriceChannel.Line           =    1; //Display line mode: 0-no,1-yes  
extern int    PriceChannel.ColorBar       =    1; //Display color bars mode: 0-no,1-yes 
extern int    PriceChannel.TimeFrame      =    0; //TimeFrame in min
extern int    PriceChannel.Nbars          = 5000;
extern int    MaBars.MA_Period            =    5;
extern int    MaBars.MA_Mode              =    0;
extern int    CciBars.PeriodCCI           =    5;
extern int    CciBars.CCI_OB              =  150;
extern int    CciBars.CCI_OS              = -150;
extern int    CciBars.TF                  =    0;
extern int    PrecisionTrend.avgPeriod    =   30;
extern double PrecisionTrend.sensitivity  =    1;

//
//
//
//
//

double uplBuffer[];
double uprBuffer[];
double dnlBuffer[];
double dnrBuffer[];
double nums[];
double nums1[];
double trend[];
int    TrendChangeValue=4;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,uplBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnlBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,uprBuffer); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,dnrBuffer); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,nums);
   SetIndexBuffer(5,nums1);
   SetIndexBuffer(6,trend);

   TrendAlignIndicators = MathMin(MathMax(TrendAlignIndicators,3),5);
      switch(TrendAlignIndicators)
      {
         case 3 :  TrendChangeValue = 0; break;
         case 4 :  TrendChangeValue = 2; break;
         case 5 :  TrendChangeValue = 4;
      }
               
   return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);

      
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      trend[i] = trend[i+1];

      //
      //
      //    collect indicators states
      //
      //

         int currentState = 0;
            
            double ptValue1 = iCustom(NULL,0,"precision trend",PrecisionTrend.avgPeriod,PrecisionTrend.sensitivity,0,i);
            double ptValue2 = iCustom(NULL,0,"precision trend",PrecisionTrend.avgPeriod,PrecisionTrend.sensitivity,1,i);
               if (ptValue1>ptValue2)
                     currentState += 1;
               else  currentState -= 1;
            double ttbValue1 = iCustom(NULL,0,"Trend_tool_bars",TrendToolBars.Length,0,i);
               if (ttbValue1 == 1)
                     currentState += 1;
               else  currentState -= 1;
            double pcValue1 = iCustom(NULL,0,"price channel stop bars",PriceChannel.ChannelPeriod,PriceChannel.Risk,0,i);
               if (pcValue1>=0)
                     currentState += 1;
               else  currentState -= 1;
            double mabValue1 = iCustom(NULL,0,"ma bars simo",MaBars.MA_Period,MaBars.MA_Mode,0,i);
            double mabValue2 = iCustom(NULL,0,"ma bars simo",MaBars.MA_Period,MaBars.MA_Mode,2,i);
               if (mabValue1 == 1 || mabValue2 == 1)
                     currentState += 1;
               else  currentState -= 1;
            double cciValue1 = iCustom(NULL,0,"cci bars simo",CciBars.PeriodCCI,CciBars.CCI_OB,CciBars.CCI_OS,0,i);
            double cciValue2 = iCustom(NULL,0,"cci bars simo",CciBars.PeriodCCI,CciBars.CCI_OB,CciBars.CCI_OS,2,i);
               if (cciValue1 == 1 || cciValue2 == 1)
                     currentState += 1;
               else  currentState -= 1;
            
      //
      //
      //
      //
      //
            
      if (currentState >  TrendChangeValue) trend[i] =  1;
      if (currentState < -TrendChangeValue) trend[i] = -1;
      bool isLight = false;
         if (currentState > -4 && trend[i] == -1) isLight = true;
         if (currentState <  4 && trend[i] ==  1) isLight = true;

      //
      //
      //
      //
      //

         uplBuffer[i] = EMPTY_VALUE;
         uprBuffer[i] = EMPTY_VALUE;
         dnlBuffer[i] = EMPTY_VALUE;
         dnrBuffer[i] = EMPTY_VALUE;
         
         if (trend[i] == 1)
         if (isLight)
               uplBuffer[i] = currentState;
         else  uprBuffer[i] = currentState;
            
         if (trend[i] == -1)
         if (isLight)
               dnlBuffer[i] = currentState;
         else  dnrBuffer[i] = currentState;
    }
   return(0);
}

